Bug 728547 - dbsetup/dbupgrade: increase size of sequence id cache for most of our tables
dbsetup/dbupgrade: increase size of sequence id cache for most of our tables
Product: RHQ Project
Classification: Other
Component: Database (Show other bugs)
Unspecified Unspecified
medium Severity medium (vote)
: ---
: ---
Assigned To: Robert Buck
Mike Foley
Depends On:
Blocks: rhq-perf 748483 748484
  Show dependency treegraph
Reported: 2011-08-05 10:07 EDT by Ian Springer
Modified: 2013-09-12 17:15 EDT (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
: 748483 (view as bug list)
Last Closed: 2013-09-12 17:15:41 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)

  None (edit)
Description Ian Springer 2011-08-05 10:07:45 EDT
currently dbssetup and dbupgrade both hardcode the cache size to 10, e.g.:

  START WITH 10001
  CACHE 10

We should make this a configurable option and increase the value for most of our tables.
Comment 1 Robert Buck 2011-10-20 08:42:02 EDT

For stuff that rarely changes (think e.g. resources / resource types  / ..) 10 is probably good so that we don't have huge holes in sequences when RHQ is restarted inbetween; or perhaps 20 .. 50 for other things (call time data or events ?) where larger values would sure be beneficial.
Comment 2 Robert Buck 2011-10-24 10:34:41 EDT
When there is a mistake as in this:

<schemaSpec version="2.115">
  <schema-createSequence name="SOMESILLYSEQUENCE_SEQ"
    initial="10001" seqIdCacheSize="WOOF"/>

You will get this sort of error:

/home/rbuck/dev/sandboxes/rhq/modules/core/dbutils/src/main/scripts/dbupgrade/db-upgrade.xml:27: Failed to upgrade - error in spec version [2.115]. Cause: Error executing the task [org.rhq.core.db.ant.dbupgrade.SST_CreateSequence] in schema spec version [2.115]. Cause: Database SEQID Cache Size is not an integer: WOOF

To specify NOCACHE:

<schema-createSequence name="SOMESILLYSEQUENCE_SEQ"
   initial="10001" seqIdCacheSize="0"/>

N.B. that for some open-source databases NOCACHE means "1", which effectively means they really don't support NOCACHE in the true sense of the word.

If the CACHE size specified is identical to the factory defaults, no CACHE terms will be applied to the generated SQL.

All negative values are mapped to the mode of using factory defaults, whatever they may be.

We need to have someone test MS Sql Server; here are the steps to test:

1. Change db-upgrade.xml:

<schemaSpec version="2.115">
  <schema-createSequence name="SOMESILLYSEQUENCE_SEQ"
    initial="10001" seqIdCacheSize="0"/>

2. Change POM.xml:

-        <db.schema.version>2.114</db.schema.version>
+        <db.schema.version>2.115</db.schema.version>

3. Run:

  mvn -Ddbsetup
Comment 3 Robert Buck 2011-10-24 11:02:02 EDT
commit 9f79315397c9bd048998bb0f72a367385f9a05cf
Author: Robert Buck <rbuck@redhat.com>
Date:   2011-10-24 11:00:54 -0400

    [BZ 728547] Make SEQID cache sizes configurable; the new solution supports NOCACHE and CACHE semantics, it supports factory default sizes; for cases where factory default sizes are larger than the previous default value of 10, we opt for the factory default sizes.
Comment 5 Jay Shaughnessy 2013-09-12 17:15:41 EDT

This seems to be done, although I believe we use the default of 10 everywhere still.  Moreover, we use increments of 1 for all entities.  If we plan on making perf enhancements for sequence cache sizes it should likely also include changes to the sequence increments for the relevant entities, as that has even more effect on perf, I think.  See Constants.ALLOCATION_SIZE for more.


Note You need to log in before you can comment on or make changes to this bug.